var comp =
{
  props:
  {
    value:
    {
      required: true
    },
    blackout:
    {
      required: false,
      default: true
    },
    heading:
    {
      required: false,
      default: "Product Info"
    },
	item:
	{
		required: true,
		type: [Object]
	}
  },
  created()
  {
  },
  data()
	{
		return{

		}
  },
  watch:
  {
    value(val) {
      this.setupWindow();
    }
  },
  methods:
  {
    close() {
      this.$emit('input', false);
    },
    setupWindow() {
      if (this.value) Vue.nextTick(() => {
        var refs = this.$refs;
        var header = refs.header;
        var window = refs.window;
        if (header && window) {
          header.onmousedown = (e) => this.mouseMove(window, e);
        }
        else {
          console.warn("if you reading this you need to have a \n\
                                :ref=\"'window'\" on the window you want to move and \n\
                                :ref=\"'header'\" on the drag control to move it\n\
                                Also make sure that the ref is not defined inside a v-if. Use a v-show instead")
        }
      });
    },
    mouseMove(element, e) {
      dragMouseDown(e)

      function dragMouseDown(e) {
        e = e || window.event;
        e.preventDefault();
        // get the mouse cursor position at startup:
        pos3 = e.clientX;
        pos4 = e.clientY;
        document.onmouseup = closeDragElement;
        // call a function whenever the cursor moves:
        document.onmousemove = elementDrag;
      }

      function elementDrag(e) {
        e = e || window.event;
        e.preventDefault();
        // calculate the new cursor position:
        pos1 = pos3 - e.clientX;
        pos2 = pos4 - e.clientY;
        pos3 = e.clientX;
        pos4 = e.clientY;
        // set the element's new position:
        element.style.top = (element.offsetTop - pos2) + "px";
        element.style.left = (element.offsetLeft - pos1) + "px";
      }

      function closeDragElement() {
        // stop moving when mouse button is released:
        document.onmouseup = null;
        document.onmousemove = null;
      }
    },
    hello(e) {
      console.log(e)
    }
  }
};