$path = function()
{
  return "../../";
}

function _externLoadComponent(resolv, reject, tag)
{
	fetch("core/comp/comp.php?comp="+tag+"&path="+Comp.path)
	.then((response) => response.text())
	.then((text) => 
	{
		var json = "//"+ tag + "\n"+text;
		eval(json); 
		if(newStyle)
		{
		var div = document.createElement("DIV");
		div.innerHTML = "<style>"+newStyle+"</style>";
		document.body.appendChild(div);
		}
		resolv(comp)
	})
	.catch((error) => reject(error));
}

async function api(path, data)
{
    var headers = new Headers({ 'Content-type': 'application/x-www-form-urlencoded; charset=UTF-8' });
    var request = data? {request :JSON.stringify(data)}:{};

    var params = 
    {
      method: 'post',
      body: new URLSearchParams(request),
      headers: headers
    }
	var post = await fetch(path,params);
	
    var result = {};
    var res_text = "";
    try 
    {
		res_text = await post.text();
		result = res_text?JSON.parse(res_text):{};
    } catch (error) 
    {
		result = {};
		result.error = error
		result.text = res_text;
	}
	
    return result;
}

function getLength(input)
{
	return (input && typeof input == "object")? Object.keys(input).length:0;
}

function getDatetimeString()
{
  var d = new Date();
  var year = d.getFullYear();
  var month = ("0"+(d.getMonth()+1)).slice(-2)
  var day =   ("0" + d.getDate()).slice(-2);
  var hours = ("0" + d.getHours()).slice(-2);
  var mins = ("0" + d.getMinutes()).slice(-2);
  var secs = ("0" + d.getSeconds()).slice(-2);

  return year + "-" + month + "-" + day + " " + hours + ":" + mins + ":" +secs;
}

function filterObj(obj,...keys)
{
	if(!obj || isEmpty(obj)) return {};
	console.log(keys);
	var clone = deepCopy(obj);
	var output = {};
	if(keys)
	{
		for(var key in keys)
		{
			var obj_key = keys[key];
			output[obj_key] = clone[obj_key]
		}
	}
	return output;
}

function deepCopy(inObj)
{
	var outObj, value, key;

	if (typeof inObj !== "object" || inObj === null) 
	{
		return inObj;
	}

	// Create an array or object to hold the values
	outObj = Array.isArray(inObj) ? [] : {}

	for (key in inObj)
	{
		value = inObj[key]

		// Recursively (deep) copy for nested objects, including arrays
		outObj[key] = deepCopy(value)
	}

	return outObj
}

function isEmpty(obj)
{
	if(!obj)return true;
	if(obj.constructor === Object && Object.keys(obj).length === 0) return true;
	if(obj.constructor === Array && obj.length === 0) return true;
	return false;
}

function getKeys(obj)
{
	if(!obj)return [];
	if(obj.constructor === Object) return Object.keys(obj);
	if(obj.constructor === Array) return obj.keys();
}


function mergeDeep(target, source) 
{
	let output = Object.assign({}, target);
	if (isObject(target) && isObject(source)) 
	{
		Object.keys(source).forEach(key => 
		{
			if (isObject(source[key])) 
			{
				if (!(key in target))	Object.assign(output, { [key]: source[key] });
				else	output[key] = mergeDeep(target[key], source[key]);
			} 
			else 
			{
				Object.assign(output, { [key]: source[key] });
			}
	  	});
	}
	return output;
}

function isObject(item) 
{
	return (item && typeof item === 'object' && !Array.isArray(item));
}

var Util=
{
	getAuthData(user)
	{
		var auth_data = {};
		var result = "";
		var characters = "0123456789101112131415ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz";
		var charactersLength = characters.length;
		for (var i = 0; i < 34; i++)
		{
			result += characters.charAt(Math.floor(Math.random() * charactersLength));
		}

		auth_data.auth_hash = result;

		var date_time_created = this.formatDateTime(new Date());
		auth_data.auth_created = date_time_created;
		
		var login_date = new Date(); 
		login_date.setDate(login_date.getDate());
		
		var date_time_login = this.formatDateTime(login_date);
		auth_data.auth_logged_in = date_time_login;

		auth_data.auth_deleted = 0;
		auth_data.user_id = user.id;

		return auth_data;
	},
	getData(api)
	{
		var res = api.response||{};
		return res.data || {};
	},
	setTableAction(table,action,request)
	{
		request =request|| {};
		request.table = table;
		request.action = action;
		return request;
	},
	formatDateTime(date)
	{
		var dd = String(date.getDate()).padStart(2, '0');
		var mm = String(date.getMonth() + 1).padStart(2, '0');
		var yyyy = date.getFullYear();
		var time = date.toString().split(' ')[4];
		date = yyyy + '-' + mm + '-' + dd + ' ' + time;
		return date;
	},
	validateEmail(email_address) 
	{
		var error = true;
		var mail_format = /[^@]+@[^.]+\.[^.]+/g;
		if (!email_address.match(mail_format)) 
		{
			error = false;
		}
		return error;
	},
	isNumber(num)
	{
		var valid_chars = "0123456789";
		var is_number = true;
		var char;
		for (i = 0; i < num.length && is_number == true; i++)
		{
			char = num.charAt(i);
			if (valid_chars.indexOf(char) == -1) is_number = false;
		}

		return is_number;
	}
}
