var DB = 
{
	async setlink(table,parent_id,child_type,child_id,data,id)
	{
		request = Util.setTableAction(table,"update");

		request.data ={};
		request.data.parent_id = parent_id;
		request.data.child_type = child_type;
		request.data.child_id = child_id;
		if(data)request.data.data = JSON.stringify(data);
		if(id)request.data.id = id;
	
		return await comp_api(request);
	},
	async getLinks(table,parent,parent_id,child_type,child_id,request)
	{
		request = Util.setTableAction(table,"list",request);

		request.join = "INNER JOIN "+child_type+" ON "+child_type+".id = child_id ";
		request.join += "INNER JOIN "+parent+" ON "+parent+".id = parent_id ";
		if(child_type)request.where = "WHERE child_type = '"+child_type+"' ";
		if(parent_id)request.where += "WHERE parent_id="+parent_id+" ";
		if(child_id)request.where += "WHERE child_id = "+child_id;

		return Util.getData(await comp_api(request)||{});
	},

	async removeLinks(table,client_id,child)
	{
		if(!client_id && isEmpty(child)) return {};
		request = Util.setTableAction(table,"delete");

		request.data = {}
		if(!isEmpty(child))
		{
			request.data.where = "WHERE child_id = " +child.id+" ";
			request.data.where += "WHERE child_type = '" +child.type+"' ";
		}
		else if(client_id)request.data.where = "WHERE client_id = " +client_id;
		return  request.data.where ? await comp_api(request):{};
	},
	async save(table,data)
	{
		if(!data) return {};
		request = Util.setTableAction(table,"update");
		request.data = data;

		var save_data = Util.getData(await comp_api(request));

		return save_data;
	},
	async edit(table,data)
	{
		if(!data) return {};
		request = Util.setTableAction(table,"edit_address");
		request.data = data;

		var save_data = Util.getData(await comp_api(request));

		return save_data;
	},
	async fetchUser(table,data)
	{
		if(!data) return {};
		request = Util.setTableAction(table,"select_user");
		request.data = data;

		var user_fetch = Util.getData(await comp_api(request));

		return user_fetch;
	},
	async fetchClientId(table,data)
	{
		if(!data) return {};
		request = Util.setTableAction(table,"select_client_id");
		request.data = data;

		var user_fetch = Util.getData(await comp_api(request));

		return user_fetch;
	},
	async getUserIdFromClientId(table,data)
	{
		if(!data) return {};
		request = Util.setTableAction(table,"get_user_id_from_client_id");
		request.data = data;

		var user_fetch = Util.getData(await comp_api(request));

		return user_fetch;
	},
	async getClientIdFromOrderId(table,data)
	{
		if(!data) return {};
		request = Util.setTableAction(table,"get_client_id_from_order_id");
		request.data = data;

		var user_fetch = Util.getData(await comp_api(request));

		return user_fetch;
	},
	async fetchClientFromClientId(table,data)
	{
		if(!data) return {};
		request = Util.setTableAction(table,"select_client_from_client_id");
		request.data = data;

		var user_fetch = Util.getData(await comp_api(request));

		return user_fetch;
	},
	async fetchClientFromClientEmail(table,data)
	{
		if(!data) return {};
		request = Util.setTableAction(table,"select_client_from_client_email");
		request.data = data;

		var user_fetch = Util.getData(await comp_api(request));

		return user_fetch;
	},
	async getAuthFromAuthHash(table,data)
	{
		if(!data) return {};
		request = Util.setTableAction(table,"select_auth_from_auth_hash");
		request.data = data;
		
		var user_fetch = Util.getData(await comp_api(request));

		return user_fetch;
	},
	async getUserFromUserId(table,data)
	{
		if(!data) return {};
		request = Util.setTableAction(table,"get_user_from_user_id");
		request.data = data;
		
		var user_fetch = Util.getData(await comp_api(request));

		return user_fetch;
	},
	async deleteAuth(table,data)
	{
		if(!data) return {};
		request = Util.setTableAction(table,"delete_auth");
		request.data = data;

		var save_data = Util.getData(await comp_api(request));

		return save_data;
	},
	async getOrderFromOrderNumber(table,data)
	{
		if(!data) return {};
		request = Util.setTableAction(table,"get_order_from_order_number");
		request.data = data;
		
		var user_fetch = Util.getData(await comp_api(request));

		return user_fetch;
	},
	async editOrder(table,data)
	{
		if(!data) return {};
		request = Util.setTableAction(table,"edit_order");
		request.data = data;

		var edit_data = Util.getData(await comp_api(request));

		return edit_data;
	},
	async getOrders(table,data)
	{
		if(!data) return {};
		request = Util.setTableAction(table,"get_orders");
		request.data = data;
		
		var order_fetch = Util.getData(await comp_api(request));

		return order_fetch;
	},
}